ReadyCheckWindow = class(Turbine.UI.Window)
function ReadyCheckWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor(self)
    self.activeReadyCheck = false
    self.countdownTimer = 0 --
    local readyCheckStartTime = 0
    local oldGameTime = Turbine.Engine.GetGameTime()
    self.width = 400
    local height = 150
    self:SetSize(self.width,height)
    self:SetPosition( math.floor(Turbine.UI.Display.GetWidth() / 2 - (self.width/2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (height /2) - 2))
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetZOrder(1)
    --self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    --self:SetWantsUpdates(false)
    self:SetText("Ready Check")
    self:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)    

    -- Yellow 0x410D7A01
    -- Green  0x410D7A02
    -- Red    0x410D7A03

    self.SetReady = function()
        --self:SetWantsUpdates(false)
        if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
        self.updateCallback = nil
        self:SetVisible(false)
    end

    self.timerBarShell = Turbine.UI.Label()
    self.timerBarShell:SetParent(self)
    self.timerBarShell:SetSize(self.width - 20 + 4, 10 + 4)
    --self.timerBarShell:SetBackColor(Turbine.UI.Color(1, 1, 1))
    self.timerBarShell:SetPosition(10 - 2, 80 - 2)

    self.timerBar = Turbine.UI.Label()
    self.timerBar:SetParent(self)
    self.timerBar:SetSize(self.width - 20, 10)
    self.timerBar:SetBackColor(Turbine.UI.Color.DarkGreen)
    self.timerBar:SetPosition(10, 80)

    self.confirmLabel = Turbine.UI.Label()
    self.confirmLabel:SetVisible(true)
    self.confirmLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.confirmLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.confirmLabel:SetOutlineColor(Turbine.UI.Color(0,0,0))
    self.confirmLabel:SetText("ARE YOU READY?!")
    self.confirmLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.confirmLabel:SetParent(self)
    self.confirmLabel:SetSize(400, 40)
    self.confirmLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.confirmLabel:SetPosition(0, 40)

    self.readyButton = Turbine.UI.Lotro.Quickslot()
    self.readyButton:SetParent(self)
    self.readyButton:SetUseOnRightClick(false)
    self.readyButton:SetShortcut()
    self.readyButton:SetPosition(108, 108)
    self.readyButton:SetParent(self)
    self.readyButton:SetMouseVisible((true))
    self.readyButton:SetWantsKeyEvents(true)
    self.readyButton:SetSize(15, 18)

    self.readyCover = Turbine.UI.Label()
    self.readyCover:SetParent(self)
    self.readyCover:SetBackground(0x410D7A02)
    self.readyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.readyCover:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.readyCover:SetParent(self)
    self.readyCover:SetSize(24,32)
    self.readyCover:SetPosition(100, 100)
    self.readyCover:SetMouseVisible(false)
    --self.readyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.ActionCheck = function()
        --self:SetWantsUpdates(false)
        if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
        self.updateCallback = nil
        self:SetVisible(false)
    end

    self.notReadyButton = Turbine.UI.Lotro.Quickslot()
    self.notReadyButton:SetParent(self)
    self.notReadyButton:SetUseOnRightClick(false)
    self.notReadyButton:SetShortcut()
    self.notReadyButton:SetPosition(281, 108)
    self.notReadyButton:SetParent(self)
    self.notReadyButton:SetSize(15, 15)

    self.notReadyCover = Turbine.UI.Label()
    self.notReadyCover:SetParent(self)
    self.notReadyCover:SetBackground(0x410D7A03)
    self.notReadyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.notReadyCover:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    self.notReadyCover:SetSize(24,32)
    self.notReadyCover:SetPosition(276, 100)
    self.notReadyCover:SetParent(self)
    self.notReadyCover:SetMouseVisible(false)
    --self.notReadyCover:SetBackColorBlendMode(Turbine.UI.BlendMode.None)

    self.notReadyButton.Click = function()
        self.ActionCheck()
    end

    self.MakeReadyCheck = function()
        self.countdownTimer = 60
        self:SetVisible(true)
        --self:SetWantsUpdates(true)
        if not(self.updateCallback) then self.updateCallback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
        self.timerBar:SetSize(self.width - 20, 10)
        local channel = "f"
        if Turbine.Gameplay.LocalPlayer.GetInstance():GetParty():GetMemberCount() > 6 then
            channel = "ra"
        end
        self.activeReadyCheck = true
        local readyShortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. channel .. " " .. Turbine.Gameplay.LocalPlayer.GetInstance():GetName() .. " Ready ")
        local notReadyShortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "/" .. channel .. " " .. Turbine.Gameplay.LocalPlayer.GetInstance():GetName() .. " Not Ready ")

        self.readyCover.MouseLeave=function(s,a)
            self.readyCover:SetShortcut(nil)
            self.readyCover:SetShortcut(readyShortcut)
        end	

        self.notReadyCover.MouseLeave=function(s,a)
            self.notReadyCover:SetShortcut(nil)
            self.notReadyCover:SetShortcut(notReadyShortcut)
        end	

        self.readyButton:SetShortcut(readyShortcut)
        self.notReadyButton:SetShortcut(notReadyShortcut)

    end

    self.OngoingReadycheck = function()
        return(self.activeReadyCheck)
    end

    self.ExecuteUpdate = function(delta)
        self.countdownTimer = self.countdownTimer - delta
    
        if self.countdownTimer > 0 then
            self.timerBar:SetSize((self.width - 20) / (60/self.countdownTimer), 10)
        else
            --self:SetWantsUpdates(false)
            if self.updateCallback then if self.updateCallback then RemoveCallback(Updater, "ExecuteUpdate", self.updateCallback) end end
            self.updateCallback = nil
            self:SetVisible(false)
            self.activeReadyCheck = false
        end
    end
end